<?php

/*
Plugin Name: BrewPixel Shortcodes
Plugin URI: http://brewpixel.com/plugins/brewpixel-shortcodes
Description: A brief description of the Plugin.
Version: 1.0.0
Author: Martin Goldie
Author URI: http://brewpixel.com
License:
*/

class Shortcode_Tinymce
{
	public function __construct()
	{
		add_action('admin_init', array($this, 'bp_shortcode_button'));
		add_action('admin_footer', array($this, 'bp_get_shortcodes'));
	}

	public function bp_shortcode_button()
	{
		if( current_user_can('edit_posts') &&  current_user_can('edit_pages') )
		{
			add_filter( 'mce_external_plugins', array($this, 'bp_add_buttons' ));
			add_filter( 'mce_buttons', array($this, 'bp_register_buttons' ));
		}
	}

	public function bp_add_buttons( $plugin_array )
	{
		if ( version_compare( $GLOBALS['wp_version'], '3.9', '>' ) ) {
			$plugin_array['bpshortcodes'] = plugin_dir_url( __FILE__ ) . 'js/shortcodes-3-9.js';
		} else {
			$plugin_array['bpshortcodes'] = plugin_dir_url( __FILE__ ) . 'js/shortcodes-3-8.js';
		}
		return $plugin_array;
	}

	public function bp_register_buttons( $buttons )
	{
		array_push( $buttons, 'separator', 'bpshortcodes' );
		return $buttons;
	}

	public function bp_get_shortcodes()
	{
		global $shortcode_tags;

		echo '<script type="text/javascript">
        var shortcodes_button = new Array();';

		$count = 0;

		foreach($shortcode_tags as $tag => $code)
		{
			if (!is_array($code)) {
				if ( strpos( $code, 'bp' ) === 0 ) {
					echo "shortcodes_button[{$count}] = '{$tag}';";
					$count ++;
				}
			}
		}

		echo '</script>';
	}
}

new Shortcode_Tinymce();